/*
 * Proyecto: ArrayBrowse
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 07/10/2020
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   component oFontBold AS TFont

   COMPONENT oSQLiteDataSource1
   COMPONENT oBevel1
   COMPONENT oBrowseMod1
   COMPONENT oButtonMod1
   COMPONENT oSQLTable1
   COMPONENT oButtonMod2
   COMPONENT oLabelEx1
   COMPONENT oButtonMod3
   COMPONENT oButtonMod4
   COMPONENT oButtonMod5

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD ButtonMod1Click( oSender )
   METHOD ButtonMod2Click( oSender )
   METHOD BrowseMod1DrawCell( oSender, oCol, nIndex, xValue, cValue, nImage, nClrText, nClrPane, nState, hDC, aRect )
   METHOD FormDestroy( oSender )
   METHOD BrowseMod1DrawHeader( oSender, oItem, cText, nImage, nClrText, nClrPane, hDC, aRect )
   METHOD ButtonMod3Click( oSender )
   METHOD BrowseMod1DblClick( oSender, nKeyFlags, oCol, nIndex )
   METHOD BrowseMod1Click( oSender, nKeyFlags, oCol, nIndex )
   METHOD ButtonMod4Click( oSender )
   METHOD BrowseMod1DrawRecSelector( oSender, nItem, cValue, nImage, nClrText, nClrPane, hDC, aRect )
   METHOD ButtonDelete( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1

   SET CENTURY ON
   SET DATE ITALIAN

   ::oFontBold := ::oFont:Clone()
   ::oFontBold:lBold := .T.

   ::oSQLiteDataSource1:lConnected := .T.
   ::oSQLTable1:lOpen := .T.

   WITH OBJECT ::oBrowseMod1
      :aGridData := ::oSQLTable1:GetRows()
//      :aCols[1]:cFilter := "Ro"
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD ButtonMod1Click( oSender ) CLASS TForm1

   WITH OBJECT ::oBrowseMod1
      :lFilterBar := !:lFilterBar
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD ButtonMod2Click( oSender ) CLASS TForm1

   ::oBrowseMod1:Edit()

RETURN NIL

//------------------------------------------------------------------------------

METHOD BrowseMod1DrawCell( oSender, oCol, nIndex, xValue, cValue, nImage, nClrText, nClrPane, nState, hDC, aRect ) CLASS TForm1

   REDECLARE oCol as TBrwColMod

   SelectObject( hDC, ::oFont:Handle )

   WITH object oCol
      IF :nDataCol == 5 .AND. xValue > 0
         cValue := :aEditListText[ xValue ]
         IF cValue != "Uno"
            SelectObject( hDC, ::oFontBold:Handle )
         ENDIF
//      ELSEIF :nDataCol == 10
//         IF xValue
//            nImage := 1
//         ENDIF
//         cValue := ""
      ENDIF
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

FUNCTION FilterNPago( oCol, cFilter )

   LOCAL nPos

   WITH OBJECT oCol
      nPos := AScan( :aEditListText, {| v | Upper( v ) = Upper( cFilter ) } )
      IF nPos > 0
         cFilter := ToString( :aEditListBound[ nPos ] )
      ENDIF
   END WITH

RETURN cFilter

//------------------------------------------------------------------------------

METHOD FormDestroy( oSender ) CLASS TForm1

   ::oFontBold:End()

RETURN NIL

//------------------------------------------------------------------------------

METHOD BrowseMod1DrawHeader( oSender, oItem, cText, nImage, nClrText, nClrPane, hDC, aRect ) CLASS TForm1

   REDECLARE oItem as CLASS THeaderItemMod

   SelectObject( hDC, ::oFont:Handle )

   WITH object oItem
      IF :cHeader == "Street"
         SelectObject( hDC, ::oFontBold:Handle )
      ENDIF
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD ButtonMod3Click( oSender ) CLASS TForm1

   LOCAL oCol

   WITH OBJECT ::oBrowseMod1
      //:AdjustCols()
      :StretchCols()
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD BrowseMod1DblClick( oSender, nKeyFlags, oCol, nIndex ) CLASS TForm1

   IF oCol != nil
      LogDebug( "Doble click on column " + oCol:cHeader )
   ENDIF

RETURN NIL

//------------------------------------------------------------------------------

METHOD BrowseMod1Click( oSender, nKeyFlags, oCol, nIndex ) CLASS TForm1

   IF oCol != nil
      LogDebug( "Click on column " + oCol:cHeader )
   ENDIF

RETURN NIL

//------------------------------------------------------------------------------

METHOD ButtonMod4Click( oSender ) CLASS TForm1

   ::oBrowseMod1:ToExcel()

RETURN Nil

//------------------------------------------------------------------------------

METHOD BrowseMod1DrawRecSelector( oSender, nItem, cValue, nImage, nClrText, nClrPane, hDC, aRect ) CLASS TForm1

   cValue := ToString( nItem )

RETURN Nil

//------------------------------------------------------------------------------

METHOD ButtonDelete( oSender ) CLASS TForm1

::oBrowseMod1:Delete()

RETURN Nil

//------------------------------------------------------------------------------
/*

CLASS TBrwModGrid FROM xBrwModGrid

   METHOD Delete()

ENDCLASS

//------------------------------------------------------------------------------

METHOD Delete() CLASS TBrwModGrid

   LOCAL aWork := ::FaWork
   LOCAL n := aWork[::nIndex]

   HB_ADel( aWork, ::nIndex, .t. )

   AEval( aWork, {|v,e| IIF( v > n, aWork[ e ] := v - 1, ) } )

   ::nIndex := Min( ::FnIndex, Len( aWork ) )

RETURN NIL

//------------------------------------------------------------------------------

*/